Wt: Wt::WFileUpload Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WFileUpload Class Reference

A widget that allows a file to be uploaded. More...

`#include <Wt/WFileUpload.h>`

Inheritance diagram for Wt::WFileUpload:
[legend]

## Public Member Functions
| WFileUpload ()
| Creates a file upload widget.
void | setMultiple (bool multiple)
| Sets whether the file upload accepts multiple files.
bool | multiple () const
| Returns whether multiple files can be uploaded.
void | setFileTextSize (int chars)
| Sets the size of the file input.
int | fileTextSize () const
| Returns the size of the file input.
std::string | spoolFileName () const
| Returns the spooled location of the uploaded file.
WString | clientFileName () const
| Returns the client filename.
WString | contentDescription () const
| Returns the client content description.
void | stealSpooledFile ()
| Steals the spooled file.
bool | empty () const
| Returns whether one or more files have been uploaded.
const std::vector< Http::UploadedFile > & | uploadedFiles () const
| Returns the uploaded files.
bool | canUpload () const
| Returns whether upload() will start a new file upload.
void | setDisplayWidget (WInteractWidget *widget)
| Use the click signal of another widget to open the file picker.
EventSignal & | uploaded ()
| Signal emitted when a new file was uploaded.
JSignal< ::int64_t > & | fileTooLarge ()
| Signal emitted when the user tried to upload a too large file.
EventSignal & | changed ()
| Signal emitted when the user selected a new file.
void | upload ()
| Starts the file upload.
void | setProgressBar (WProgressBar *progressBar)
| Sets a progress bar to indicate upload progress.
void | setProgressBar (std::unique_ptr< WProgressBar > progressBar)
| Sets a progress bar to indicate upload progress.
WProgressBar * | progressBar () const
| Returns the progress bar.
Signal< ::uint64_t, ::uint64_t > & | dataReceived ()
| Signal emitted while a file is being uploaded.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setFilters (const std::string &acceptAttributes)
| Sets input accept attributes.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that allows a file to be uploaded.

This widget is displayed as a box in which a filename can be entered and a browse button.

Depending on availability of JavaScript, the behaviour of the widget is different, but the API is designed in a way which facilitates a portable use.

When JavaScript is available, the file will not be uploaded until upload() is called. This will start an asynchronous upload (and thus return immediately). While the file is being uploaded, the dataReceived() signal is emitted when data is being received and if the connector library provides support (see also WResource::setUploadProgress() for a more detailed discussion). Although you can modify the GUI from this signal, you still need to have a mechanism in place to update the client interface (using a WTimer or using server-push). When the file has been uploaded, the uploaded() signal is emitted, or if the file was too large, the fileTooLarge() signal is emitted. You may configure a progress bar that is used to show the upload progress using setProgressBar().

When no JavaScript is available, the file will be uploaded with the next click event. Thus, upload() has no effect – the file will already be uploaded, and the corresponding signals will already be emitted. To test if upload() will start an upload, you may check using the canUpload() call.

Thus, to properly use the widget, one needs to follow these rules:

- Be prepared to handle the uploaded() or fileTooLarge() signals also when upload() was not called.
- Check using canUpload() if upload() will schedule a new upload. if (!canUpload()) then upload() will not have any effect. if (canUpload()), upload() will start a new file upload, which completes succesfully using an uploaded() signal or a fileTooLarge() signals gets emitted.

The WFileUpload widget must be hidden or deleted when a file is received. In addition it is wise to prevent the user from uploading the file twice as in the example below.

The uploaded file is automatically spooled to a local temporary file which will be deleted together with the WFileUpload widget, unless stealSpooledFile() is called.

Usage example:

Wt::WFileUpload *upload = addWidget(std::make_unique<Wt::WFileUpload>());
upload->setFileTextSize(40);
// Provide a button
Wt::WPushButton *uploadButton =
addWidget(std::make_unique<Wt::WPushButton>("Send"));
// Upload when the button is clicked.
uploadButton->clicked().connect(upload, &Wt::WFileUpload::upload);
uploadButton->clicked().connect(uploadButton, &Wt::WPushButton::disable);
// Upload automatically when the user entered a file.
upload->changed().connect(upload, &WFileUpload::upload);
upload->changed().connect(uploadButton, &Wt::WPushButton::disable);
// React to a succesfull upload.
upload->uploaded().connect(this, &MyWidget::fileUploaded);
// React to a fileupload problem.
upload->fileTooLarge().connect(this, &MyWidget::fileTooLarge);
Wt::WFileUpload
A widget that allows a file to be uploaded.
Definition WFileUpload.h:104
Wt::WFileUpload::upload
void upload()
Starts the file upload.
Wt::WInteractWidget::clicked
EventSignal< WMouseEvent > & clicked()
Event signal emitted when the primary mouse button was clicked on this widget.
Wt::WPushButton
A widget that represents a push button.
Definition WPushButton.h:42
Wt::WWidget::disable
void disable()
Disable thes widget.

WFileUpload is an inline widget.

### CSS

The file upload itself corresponds to a `<input type="file">` tag, but may be wrapped in a `<form>` tag for an Ajax session to implement the asynchronous upload action. This widget does not provide styling, and styling through CSS is not well supported across browsers.

## Member Function Documentation

## ◆ canUpload()

bool Wt::WFileUpload::canUpload | ( |  | ) | const

Returns whether upload() will start a new file upload.

A call to upload() will only start a new file upload if there is no JavaScript support. Otherwise, the most recent file will already be uploaded.

## ◆ changed()

EventSignal & Wt::WFileUpload::changed | ( |  | ) |

Signal emitted when the user selected a new file.

One could react on the user selecting a (new) file, by uploading the file immediately.

Caveat: this signal is not emitted with konqueror and possibly other browsers. Thus, in the above scenario you should still provide an alternative way to call the upload() method.

## ◆ clientFileName()

WString Wt::WFileUpload::clientFileName | ( |  | ) | const

Returns the client filename.

When multiple files were uploaded, this returns the information from the first file.

Note
  Depending on the browser this is an absolute path or only the file name.

## ◆ contentDescription()

WString Wt::WFileUpload::contentDescription | ( |  | ) | const

Returns the client content description.

When multiple files were uploaded, this returns the information from the first file.

## ◆ dataReceived()

Signal< ::uint64_t, ::uint64_t > & Wt::WFileUpload::dataReceived | ( |  | ) |

Signal emitted while a file is being uploaded.

When supported by the connector library, you can track the progress of the file upload by listening to this signal.

The first argument is the number of bytes received so far, and the second argument is the total number of bytes.

## ◆ enableAjax()

virtual void Wt::WFileUpload::enableAjax | ( |  | ) |
| overridevirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WWebWidget.

## ◆ fileTooLarge()

JSignal< ::int64_t > & Wt::WFileUpload::fileTooLarge | ( |  | ) |

Signal emitted when the user tried to upload a too large file.

The parameter is the (approximate) size of the file (in bytes) the user tried to upload.

The maximum file size is determined by the maximum request size, which may be configured in the configuration file (<max-request-size>).

See also
  uploaded()
  WApplication::requestTooLarge()

## ◆ multiple()

bool Wt::WFileUpload::multiple | ( |  | ) | const

Returns whether multiple files can be uploaded.

See also
  setMultiple()

## ◆ progressBar()

WProgressBar * Wt::WFileUpload::progressBar | ( |  | ) | const

Returns the progress bar.

See also
  setProgressBar()

## ◆ propagateSetEnabled()

virtual void Wt::WFileUpload::propagateSetEnabled | ( | bool | enabled | ) |
| overrideprotectedvirtual

Propagates that a widget was enabled or disabled through children.

When enabling or disabling a widget, you usually also want to disable contained children. This method is called by setDisabled() to propagate its state to all children.

You may want to reimplement this method if they wish to render differently when a widget is disabled. The default implementation will propagate the signal to all children.

Reimplemented from Wt::WWebWidget.

## ◆ setDisplayWidget()

void Wt::WFileUpload::setDisplayWidget | ( | WInteractWidget * | widget | ) |

Use the click signal of another widget to open the file picker.

This hides the default WFileUpload widget and uses the click-signal of the argument to open the file picker. The upload logic is still handled by WFileUpload behind the scenes. This action cannot be undone.

WFileUpload does not take ownership of the widget, nor does it display it. You must still place it in the widget tree yourself.

## ◆ setFilters()

void Wt::WFileUpload::setFilters | ( | const std::string & | acceptAttributes | ) |

Sets input accept attributes.

The accept attribute may be specified to provide user agents with a hint of what file types will be accepted. Use html input accept attributes as input.

WFileUpload *fu = new WFileUpload(root());
fu->setFilters("image/*");
Wt::WFileUpload::WFileUpload
WFileUpload()
Creates a file upload widget.
Wt::WFileUpload::setFilters
void setFilters(const std::string &acceptAttributes)
Sets input accept attributes.

## ◆ setMultiple()

void Wt::WFileUpload::setMultiple | ( | bool | multiple | ) |

Sets whether the file upload accepts multiple files.

In browsers which support the "multiple" attribute for the file upload (to be part of HTML5) control, this will allow the user to select multiple files at once.

All uploaded files are available from uploadedFiles(). The single-file API will return only information on the first uploaded file.

The default value is `false`.

## ◆ setProgressBar() [1/2]

void Wt::WFileUpload::setProgressBar | ( | std::unique_ptr< WProgressBar > | progressBar | ) |

Sets a progress bar to indicate upload progress.

When the file is being uploaded, upload progress is indicated using the provided progress bar. Both the progress bar range and values are configured when the upload starts.

The bar becomes part of the file upload, and replaces the file prompt when the upload is started.

The default progress bar is 0 (no upload progress is indicated).

See also
  dataReceived()

## ◆ setProgressBar() [2/2]

void Wt::WFileUpload::setProgressBar | ( | WProgressBar * | progressBar | ) |

Sets a progress bar to indicate upload progress.

When the file is being uploaded, upload progress is indicated using the provided progress bar. Both the progress bar range and values are configured when the upload starts.

The file upload itself is hidden as soon as the upload starts.

The default progress bar is 0 (no upload progress is indicated).

See also
  dataReceived()

## ◆ spoolFileName()

std::string Wt::WFileUpload::spoolFileName | ( |  | ) | const

Returns the spooled location of the uploaded file.

Returns the temporary filename in which the uploaded file was spooled. The file is guaranteed to exist as long as the WFileUpload widget is not deleted, or a new file is not uploaded.

When multiple files were uploaded, this returns the information from the first file.

See also
  stealSpooledFile()
  uploaded

## ◆ stealSpooledFile()

void Wt::WFileUpload::stealSpooledFile | ( |  | ) |

Steals the spooled file.

By stealing the file, the spooled file will no longer be deleted together with this widget, which means you need to take care of managing that.

When multiple files were uploaded, this returns the information from the first file.

## ◆ upload()

void Wt::WFileUpload::upload | ( |  | ) |

Starts the file upload.

The uploaded() signal is emitted when a file is uploaded, or the fileTooLarge() signal is emitted when the file size exceeded the maximum request size.

See also
  uploaded()
  canUpload()

## ◆ uploaded()

EventSignal & Wt::WFileUpload::uploaded | ( |  | ) |

Signal emitted when a new file was uploaded.

This signal is emitted when file upload has been completed. It is good practice to hide or delete the WFileUpload widget when a file has been uploaded succesfully.

See also
  upload()
  fileTooLarge()